<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
<meta http-equiv="Cache-Control" content="no-cache, must-revalidate">
<meta http-equiv="pragma" content="no-cache">
<meta name="Author" content="Michiel Dethmers, michiel@kipu.co.uk">
<meta name="Package" content="PHPList 1.1.1b, 16 October 2000">
<meta name="More Information" content="http://www.phplist.com">
	<title>Send a message to the Mailinglists</title>
</head>

<? include "header.inc" ?>

<?php

include "config.php";
echo Menu();
echo "<hr><p>";

# check the criterias, one attribute can only exist once
if ($send) {
  $used_attributes = array();
  for ($i=1;$i<=NUMCRITERIAS;$i++) {
    if (isset($use[$i])) {
      $attribute = $criteria[$i];
      if (!in_array($attribute,$used_attributes))
        array_push($used_attributes,$attribute);
      else
        $duplicate_attribute = 1;
    }
  }
}

if ($send && $subject && $message && $from && $list && !$duplicate_attribute) {
  $query = sprintf('insert into message (subject,fromfield,tofield,replyto,message,footer,status,entered) values(
      "%s","%s","%s","%s","%s","%s","%s",%s)',
      addslashes($subject),
      addslashes($from),
      addslashes($tofield),
      addslashes($replyto),
      addslashes($message),
      addslashes($footer),
      "submitted","now()");

  $result = DB_query($query);
  $messageid = DB_insert_id();
  
  if ($list) {
    if ($list["all"]) {
      $res = DB_query("select * from list");
      while($row = DB_fetch_array($res)) {
        $listid = $row["id"];
        if ($row["active"]) {
          $result = DB_query("insert into listmessage (messageid,listid,entered) values($messageid,$listid,now())");
        }
      }
    } else {
      while(list($key,$val)= each($list)) {
        if ($val == "signup")
          $result = DB_query("insert into listmessage (messageid,listid,entered) values($messageid,$key,now())");
      }
    }
  }

# we want to create a join on tables as follows, in order to find users who have their attributes to the values chosen
# (independent of their list membership).
# select 
#  table1.userid from user_attribute as table1 
#  left join user_attribute as table2 on table1.userid = table2.userid 
#  left join user_attribute as table3 on table1.userid = table3.userid 
#  ...
# where 
#  table1.attributeid = 2 and table1.value in (1,2,3,4) 
#  and table2.attributeid = 1 and table2.value in (3,15) 
#  and table3.attributeid = 3 and table3.value in (4,5,6)
#  ...

  # check the criterias, create the selection query
  $used_tables = array();
  for ($i=1;$i<=NUMCRITERIAS;$i++) {
    if (isset($use[$i])) {
      $attribute = $criteria[$i];
      $values = "attr$attribute$i";
      if (isset($where_clause)) {
        $where_clause .= " and ";
        $select_clause .= " left join user_attribute as table$i on table$first.userid = table$i.userid ";
      } else {
        $select_clause = "table$i.userid from user_attribute as table$i ";
        $first = $i;
      }
      
      $where_clause .= "table$i.attributeid = $attribute and table$i.value in (";
      $list = array();
      if (is_array($$values)) {
        while (list($key,$val) = each ($$values))
          array_push($list,$val);
      } 
      $where_clause .= join(",",$list) . ")";
    }
  }
  
  # if no selection was made, use all
  if (!isset($where_clause)) {
    $count_query = "select distinct userid from user_attribute";
  } else {
    $count_query = "select $select_clause where $where_clause";
  }
  
  DB_query("update message set userselection = \"$count_query\" where id = $messageid");
 # commented, because this could take too long
 # DB_Query($count_query);
 # $num = DB_Affected_rows();

  ?>
  <h3>Message Queued for sending</h3>
  <? #echo $num ?> <!--users apply (at the moment, independent of list membership)<p>-->
  
<?php  
  echo Menu();
  exit;
} elseif ($send && !$from) {
  ?>
  <font color=red size=+2>Please enter a from line</font><br>
  <?
} elseif ($send && !$message) {
  ?>
  <font color=red size=+2>Please enter a message</font><br>
  <?
} elseif ($send && !$subject) {
  ?>
  <font color=red size=+2>Please enter a subject</font><br>
  <?
} elseif ($send && !$list) {
  ?>
  <font color=red size=+2>Please choose a list to send to</font><br>
  <?
} elseif ($send && $duplicate_attribute) {
  ?>
  <font color=red size=+2>Error: you can use an attribute in one rule only</font><br>
  <?
}

if (!$footer)
  $footer = "--\nTo unsubscribe from this list go to [UNSUBSCRIBE]\n";

echo $msg;

?>
<form method=post>
<table>
<tr><td>Subject:</td><td><input type=text name=subject value="<?php echo $subject?>" size=40></td></tr>
<tr><td colspan=2>
<p>
You can use three different methods to set the from line:
<ul>
<li>One word: this will be reformatted as &lt;the word&gt;@<? echo getenv("SERVER_NAME"); ?>
<br>For example: <b>information</b> will become <b>information@<? echo getenv("SERVER_NAME"); ?></b>
<br>In most email programs this will show up as being from <b>information@<? echo getenv("SERVER_NAME"); ?></b>
<li>Two or more words: this will be reformatted as <i>the words you type</i> &lt;listmaster@<? echo getenv("SERVER_NAME"); ?>&gt;
<br>For example: <b>list information</b> will become <b>list information &lt;listmaster@<? echo getenv("SERVER_NAME"); ?>&gt; </b>
<br>In most email programs this will show up as being from <b>list information</b>
<li>Zero or more words and an email address: this will be reformatted as <i>Words</i> &lt;emailaddress&gt;
<br>For example: <b>My Name my@email.com</b> will become <b>My Name &lt;my@email.com&gt;</b>
<br>In most email programs this will show up as being from <b>My Name</b>

</ul>
</td></tr>

<tr><td>From line:</td><td><input type=text name=from value="<?php echo $from?>" size=40></td></tr>
<tr><td colspan=2>
In the message field you can (currently) use one "variable", which will be replaced by the appropriate value:
<br>If you type [NAME] somewhere in the message it will be replaced by the name that the person who
received the message has entered.
</td></tr>
<tr><td colspan=2>Message:</td></tr>
<tr><td colspan=2><textarea name=message cols=50 rows=20><?php echo $message?></textarea></td></tr>
<tr><td colspan=2>Message Footer, use [UNSUBSCRIBE] to insert the personal unsubscribe URL for each user</td></tr>
<tr><td colspan=2><textarea name=footer cols=70 rows=5><?php echo $footer ?></textarea></td></tr>

</table>

<p>Please select the lists you want to send it to:
<ul>
<li><input type=checkbox name=list[all] value=signup>All Lists
<?php

echo "<input type=hidden name=referer value=\"$PHP_REFERER\">\n";
$result = DB_query("SELECT * FROM list");
while ($row = DB_fetch_array($result)) {
  print "<li><input type=checkbox name=list[".$row["id"] . "] value=signup ";
  if ($list[$row["id"]] == "signup")
    print "checked";
  print ">".$row["name"];
  if ($row["active"])
    print " (<font color=red>List is Active</font>)";
  else 
    print " (<font color=red>List is not Active</font>)";

  $desc = nl2br(StripSlashes($row["description"]));
  
  echo "<dd>$desc";
  $some = 1;
}

if (!$some) 
  echo "Sorry there are currently no lists available";

?>
<p><b>Select the criteria for this message:</b>
<ol>
<li>to use a criteria, check the box next to it
<li>then check the radio button next to the attribute you want to use
<li>then choose the values of the attributes you want to send the message to
</ul>
<i>Note:</i> Messages will be sent to people who fit to <i>Criteria 1</i> <b>AND</b> <i>Criteria 2</i> etc
<table>
<?

for ($i=1;$i<=NUMCRITERIAS;$i++) {
  print "<tr><td colspan=2><hr><h3>Criteria $i</h3></td><td>Use this one <input type=checkbox name=\"use[$i]\"></tr>";
  $attributes_request = DB_Query("select * from attribute");
  while ($attribute = DB_Fetch_array($attributes_request)) {
    switch ($attribute["type"]) {
      case "checkbox":
        printf ('<tr><td><input type="radio" name="criteria[%d]" value="%d"> %s</td><td><b>IS</b></td><td><select name="attr%d%d[]">
                <option value="0">Not checked
                <option value="1">Checked</select></td></tr>',$i,$attribute["id"],$attribute["name"],$attribute["id"],$i);
        break;
      case "select":
      case "radio":
        $values_request = DB_Query("select * from listattr_".$attribute["tablename"]);
        printf ('<tr><td valign=top><input type="radio" name="criteria[%d]" value="%d"> %s</td>
                <td valign=top><b>IS</b></td><td><select name="attr%d%d[]" size=4 multiple>',$i,$attribute["id"],$attribute["name"],$attribute["id"],$i);
        while ($value = DB_Fetch_array($values_request)) {
          printf ('<option value="%d">%s',$value["id"],$value["name"]);
        }
        print "</select></td></tr>";
        break;
      default:
        print "<!-- error: huh, invalid type -->";
    }
  }
}        

?>
</table>

</ul>
<p><input type=submit name=send value="Send Message to the Selected Mailinglists">
</form>
</body>
</html>
