<?

# select the database module to use
$database_module = "mysql.inc";
# select the language module to use
$language_module = "english.inc";

# if you want more trouble, make this 63 (very unlikely you'll like the result)
$error_level = error_reporting(0);

# host is our Mysql database server
$database_host = "localhost"; # getenv('SERVER_NAME');

# report address is the person who gets the reports
$report_address = 'root@'.getenv("SERVER_NAME");

# if test is true (not 0) it will not actually send messages, but display what it would have sent
define ("TEST",1);

# the number of criterias you want to be able to select when
# sending a message. Best is to make it the same as the number of 
# attributes you enter in the system, but that's up to you
define ("NUMCRITERIAS",2);

# database is the name of the database we're using
$database_name = "phplistdb";

# who do we log in as?
$database_user = "phplist";

# and what password do we use
$database_password = 'password';

# what code do we put in the page to go back to the main admin page
$adminpage = "<a href=\"/lists/admin/\">Back to the Listadmin Page</a>";

# message that is sent when people sign up to a list
# [!-- lists --] will be replaced with the list of lists they have signed up to
$subscribemessage = '
  
  Welcome to our Mailinglist
  
  You have been subscribed to the following mailinglists:
[!-- lists --]
  
  To unsubscribe please go to http://www.phplist.com/lists/unsubscribe.php and 
  follow the steps.
  
  Thank you
  
  ';

# the subject of the message
$subscribesubject = "Welcome to our Mailinglist";

# additional headers for the subscribe message
$subscribe_additional_headers = "From: webmaster@$SERVER_NAME (Webmaster)\nReply-To: webmaster@$SERVER_NAME\nX-Mailer: PHP/" . phpversion();

# message that is sent when they unsubscribe
$unsubscribemessage = '
  
  Goodbye from our Mailinglist
  
  You have been unsubscribed from the following mailinglists:
[!-- lists --]
  
  To subscribe please go to http://www.phplist.com/lists/subscribe.php and 
  follow the steps.
  
  Thank you
  
';

# subject of the message when they unsubscribe
$unsubscribesubject = "Goodbye from our Mailinglist";

# additional headers for the unsubscribe message
$unsubscribe_additional_headers = "From: webmaster@$SERVER_NAME (Webmaster)\nReply-To: webmaster@$SERVER_NAME\nX-Mailer: PHP/" . phpversion();

# the location of your unsubscribe script:
$unsubscribe_url = "http://".getenv("SERVER_NAME") . "/lists/unsubscribe.php";

################################################################################################
# you should not need to edit below, but if things go wrong you can try to play around with it #
################################################################################################

if (file_exists($database_module))
  include $database_module; 
else
  include "admin/$database_module"; 
if (file_exists("english.inc")) # first load english and then the translation
  include "english.inc"; 
else
  include "admin/english.inc"; 
if (file_exists($language_module))
  include $language_module; 
else
  include "admin/$language_module"; 
if (file_exists("connect.php"))
  include "connect.php";
else 
  include "admin/connect.php";
  
?>