<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
<meta http-equiv="Cache-Control" content="no-cache, must-revalidate">
<meta http-equiv="pragma" content="no-cache">
<meta name="Author" content="Michiel Dethmers, michiel@kipu.co.uk">
<meta name="Package" content="PHPList 1.1.1b, 16 October 2000">
<meta name="More Information" content="http://www.phplist.com">
	<title>Configure Attributes</title>
</head>

<? 
include "header.inc";
require "config.php";
echo Menu();

if (isset($action) && $action == "Save Changes") {
  if (isset($name))
    while (list($id,$val) = each ($name)) {
      if (!$id && isset($name[0]) && $name[0] != "") {
        # it's a new one
        $lc_name = substr(str_replace(" ","", strtolower($name[0])),0,10);
        if ($lc_name == "") Fatal_Error("Name cannot be empty: $lc_name");
        DB_Query("select * from attribute where tablename = \"$lc_name\"");
        if (DB_Affected_Rows()) Fatal_Error("Name is not unique enough");
          
        $query = sprintf('insert into attribute (name,type,listorder,default_value,required,tablename) values("%s","%s",%d,"%s",%d,"%s")',
        addslashes($name[0]),$type[0],$listorder[0],addslashes($default[0]),$required[0],$lc_name);
        DB_Query($query);
        $insertid = DB_Insert_id();
        
        $query = "create table listattr_$lc_name (id integer not null primary key auto_increment, name varchar(255))";
        DB_Query($query);
        if ($type[$id] == "checkbox") {
          # with a checkbox we know the values
          DB_Query('insert into listattr_'.$lc_name.' (name) values("Checked")');
          DB_Query('insert into listattr_'.$lc_name.' (name) values("Unchecked")');
          # we cannot "require" checkboxes, that doesn't make sense
          DB_Query("update attribute set required = 0 where id = $insertid");
        }          
        
      } elseif ($name[$id] != "") {
        $query = sprintf('update attribute set name = "%s" ,type = "%s" ,listorder = %d,default_value = "%s" ,required = %d where id = %d',
        addslashes($name[$id]),$type[$id],$listorder[$id],$default[$id],$required[$id],$id);
        DB_Query($query);
      }
    }
  if (isset($delete))
    while (list($id,$val) = each ($delete)) {
      $res = DB_Query("select tablename from attribute where id = $id");
      $row = DB_Fetch_Row($res);
      DB_Query("drop table listattr_$row[0]");
      DB_Query("delete from attribute where id = $id");
    }
}
?>

<p>Here you can identify the attributes you want people to enter, in order to sign up for the lists.
<br>Attributes are "global" ie, they apply to all lists.<p>
<form method=post>
<? 
$res = DB_Query("select * from attribute order by listorder");
if (DB_Affected_Rows()) 
  print "Existing attributes:<p>";
else
  print "No Attributes have been defined yet";
while ($row = DB_Fetch_array($res)) {
  ?>
  <table border=1>
  <tr><td colspan=2>Attribute:<? echo $row["id"] ?></td><td colspan=2>Delete <input type="checkbox" name="delete[<? echo $row["id"] ?>]" value="1"></td></tr>
  <tr><td colspan=2>Name: </td><td colspan=2><input type=text name="name[<? echo $row["id"]?>]" value="<? echo htmlspecialchars(stripslashes($row["name"])) ?>" size=40></td></tr>
  <tr><td colspan=2>Type: </td><td colspan=2><select name="type[<? echo $row["id"]?>]">
  <? 
  $types = array('checkbox','radio','select');
  while (list($key,$val) = each($types)) {
    printf('<option value="%s" %s>%s',$val,$val == $row["type"] ? "selected": "",$val);
  }
  ?>
  </select></td></tr>
  <tr><td colspan=2>Default Value: </td><td colspan=2><input type=text name="default[<? echo $row["id"]?>]" value="<? echo htmlspecialchars(stripslashes($row["default_value"])) ?>" size=40></td></tr>
  <tr><td>Order of Listing: </td><td><input type=text name="listorder[<? echo $row["id"]?>]" value="<? echo $row["listorder"] ?>" size=5></td>
  <td>Is this attribute required?: </td><td><input type=checkbox name="required[<? echo $row["id"]?>]" value="1" <? echo $row["required"] ? "checked": "" ?>></td></tr>
  </table><hr>
<? } ?>

<h3>Add a new Attribute:</h3>
<table border=1>
<tr><td colspan=2>Name: </td><td colspan=2><input type=text name="name[0]" value="" size=40></td></tr>
<tr><td colspan=2>Type: </td><td colspan=2><select name="type[0]">
<? 
$types = array('checkbox','radio','select');
while (list($key,$val) = each($types)) {
  printf('<option value="%s" %s>%s',$val,"",$val);
}
?>
</select></td></tr>
<tr><td colspan=2>Default Value: </td><td colspan=2><input type=text name="default[0]" value="" size=40></td></tr>
<tr><td>Order of Listing: </td><td><input type=text name="listorder[0]" value="" size=5></td>
<td>Is this attribute required?: </td><td><input type=checkbox name="required[0]" value="1" checked></td></tr>
</table><hr>
  
<input type=submit name="action" value="Save Changes">
</form>

</body>
</html>
